#
# fishing.R, 16 Apr 21


# Size facts

library("colorspace")

pal_col=rainbow(3)

par(las=1)
par(bty="l")
par(pch="+")

sf=read.csv("data/CESAW_size_facts.csv.xz", as.is=TRUE)

# t=which(sf$size_added_and_modified != (sf$size_added+sf$size_modified))

t=sf$size_added_and_modified - (sf$size_added+sf$size_modified)
tail(sort(table(t)))

sfc=subset(sf, size_metric_short_name == "LOC")
act_sfc=subset(sfc, measurement_type_name == "Actual")
plan_sfc=subset(sfc, measurement_type_name == "Plan")

LOC_plan_act=merge(plan_sfc, act_sfc, c("person_key", "plan_item_key"))

max_x=1e4
max_y=1e5

plot(LOC_plan_act$size_added_and_modified.x, LOC_plan_act$size_added_and_modified.y, log="xy", col=pal_col[3],
	xlim=c(1, max_x), ylim=c(1, max_y),
	xlab="Estimated LOC", ylab="Actual LOC")

legend(x="bottomright", legend=c("Fitted regression line", "Actual==Estimate"), bty="n", fill=pal_col[c(1, 2)], cex=1.3)


LOC_plan_act=subset(LOC_plan_act, size_added_and_modified.y > 0)
# lpa_mod=glm(log(size_added_and_modified.y) ~ log(size_added_and_modified.x)+
#                                            I(log(size_added_and_modified.x)^2), data=LOC_plan_act)
# lpa_mod=glm(log(size_added_and_modified.y) ~ log(size_added_and_modified.x),
#                                       subset=(size_added_and_modified.x > 50),
#                                                        data=LOC_plan_act)

lpa_mod=glm(log(size_added_and_modified.y) ~ log(size_added_and_modified.x),
                                                         data=LOC_plan_act)
summary(lpa_mod)

# Actual==Estimate
lines(c(1, max_y), c(1, max_y), col=pal_col[2])

x_range=1:max_x
pred=predict(lpa_mod, newdata=data.frame(size_added_and_modified.x=x_range))

lines(x_range, exp(pred), col=pal_col[1])

tsf=merge(tf, sf, by=c("project_key", "wbs_element_key"), all=TRUE)

tsf=merge(tf, sf, by=c("person_key", "plan_item_key"), all=TRUE)

# Get project_key and wbs_element_key mapping for tf * basic_... files

# bf=read.csv("data/basic_task_fact_sheet.csv", as.is=TRUE)

# Turns out that all the keys are different
# tbf=merge(tf, bf, by=c("person_key", "plan_item_key"), all=TRUE)

# The follows works a lot better, but there rows in both files that
# are not present in the other!
tbf=merge(tf, bf, by=c("task_actual_start_date", "task_plan_time_minutes"), all.x=TRUE)

pk_notNA=subset(tbf, (!is.na(project_key.x)) & !is.na(project_key.y))

pk_xy=data.frame(pk_notNA$project_key.x, pk_notNA$project_key.y)
t=pk_xy[!duplicated(pk_xy), ]

t[order(t$pk_notNA.project_key.x),]


